Index: trunk/src/VBox/GuestHost/SharedClipboard/clipboard-common.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/clipboard-common.cpp	(revision 80845)
+++ trunk/src/VBox/GuestHost/SharedClipboard/clipboard-common.cpp	(revision 80847)
@@ -158,5 +158,5 @@
     pSource->uID          = uID;
     /* Choose a random event ID starting point. */
-    pSource->uEventIDNext = RTRandU32() % VBOX_SHARED_CLIPBOARD_MAX_EVENTS;
+    pSource->uEventIDNext = RTRandU32() % VBOX_SHCL_MAX_EVENTS;
 
     LogFlowFuncLeaveRC(rc);
@@ -205,5 +205,5 @@
 
     pSource->uEventIDNext++;
-    if (pSource->uEventIDNext == VBOX_SHARED_CLIPBOARD_MAX_EVENTS)
+    if (pSource->uEventIDNext == VBOX_SHCL_MAX_EVENTS)
         pSource->uEventIDNext = 0;
 
@@ -749,5 +749,5 @@
 
 #ifdef LOG_ENABLED
-int VBoxClipboardDbgDumpHtml(const char *pszSrc, size_t cbSrc)
+int VBoxShClDbgDumpHtml(const char *pszSrc, size_t cbSrc)
 {
     size_t cchIgnored = 0;
@@ -777,9 +777,9 @@
 }
 
-void VBoxClipboardDbgDumpData(const void *pv, size_t cb, SHCLFORMAT u32Format)
-{
-    if (u32Format & VBOX_SHARED_CLIPBOARD_FMT_UNICODETEXT)
-    {
-        LogFunc(("VBOX_SHARED_CLIPBOARD_FMT_UNICODETEXT:\n"));
+void VBoxShClDbgDumpData(const void *pv, size_t cb, SHCLFORMAT u32Format)
+{
+    if (u32Format & VBOX_SHCL_FMT_UNICODETEXT)
+    {
+        LogFunc(("VBOX_SHCL_FMT_UNICODETEXT:\n"));
         if (pv && cb)
             LogFunc(("%ls\n", pv));
@@ -787,9 +787,9 @@
             LogFunc(("%p %zu\n", pv, cb));
     }
-    else if (u32Format & VBOX_SHARED_CLIPBOARD_FMT_BITMAP)
-        LogFunc(("VBOX_SHARED_CLIPBOARD_FMT_BITMAP\n"));
-    else if (u32Format & VBOX_SHARED_CLIPBOARD_FMT_HTML)
-    {
-        LogFunc(("VBOX_SHARED_CLIPBOARD_FMT_HTML:\n"));
+    else if (u32Format & VBOX_SHCL_FMT_BITMAP)
+        LogFunc(("VBOX_SHCL_FMT_BITMAP\n"));
+    else if (u32Format & VBOX_SHCL_FMT_HTML)
+    {
+        LogFunc(("VBOX_SHCL_FMT_HTML:\n"));
         if (pv && cb)
         {
@@ -822,28 +822,28 @@
  * @param   uMsg                The message to translate.
  */
-const char *VBoxClipboardHostMsgToStr(uint32_t uMsg)
+const char *VBoxShClHostMsgToStr(uint32_t uMsg)
 {
     switch (uMsg)
     {
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_HOST_MSG_QUIT);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_HOST_MSG_READ_DATA);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_HOST_MSG_FORMATS_REPORT);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_HOST_MSG_URI_TRANSFER_STATUS);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_HOST_MSG_URI_ROOT_LIST_HDR_READ);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_HOST_MSG_URI_ROOT_LIST_HDR_WRITE);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_HOST_MSG_URI_ROOT_LIST_ENTRY_READ);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_HOST_MSG_URI_ROOT_LIST_ENTRY_WRITE);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_HOST_MSG_URI_LIST_OPEN);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_HOST_MSG_URI_LIST_CLOSE);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_HOST_MSG_URI_LIST_HDR_READ);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_HOST_MSG_URI_LIST_HDR_WRITE);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_HOST_MSG_URI_LIST_ENTRY_READ);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_HOST_MSG_URI_LIST_ENTRY_WRITE);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_HOST_MSG_URI_OBJ_OPEN);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_HOST_MSG_URI_OBJ_CLOSE);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_HOST_MSG_URI_OBJ_READ);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_HOST_MSG_URI_OBJ_WRITE);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_HOST_MSG_URI_CANCEL);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_HOST_MSG_URI_ERROR);
+        RT_CASE_RET_STR(VBOX_SHCL_HOST_MSG_QUIT);
+        RT_CASE_RET_STR(VBOX_SHCL_HOST_MSG_READ_DATA);
+        RT_CASE_RET_STR(VBOX_SHCL_HOST_MSG_FORMATS_REPORT);
+        RT_CASE_RET_STR(VBOX_SHCL_HOST_MSG_URI_TRANSFER_STATUS);
+        RT_CASE_RET_STR(VBOX_SHCL_HOST_MSG_URI_ROOT_LIST_HDR_READ);
+        RT_CASE_RET_STR(VBOX_SHCL_HOST_MSG_URI_ROOT_LIST_HDR_WRITE);
+        RT_CASE_RET_STR(VBOX_SHCL_HOST_MSG_URI_ROOT_LIST_ENTRY_READ);
+        RT_CASE_RET_STR(VBOX_SHCL_HOST_MSG_URI_ROOT_LIST_ENTRY_WRITE);
+        RT_CASE_RET_STR(VBOX_SHCL_HOST_MSG_URI_LIST_OPEN);
+        RT_CASE_RET_STR(VBOX_SHCL_HOST_MSG_URI_LIST_CLOSE);
+        RT_CASE_RET_STR(VBOX_SHCL_HOST_MSG_URI_LIST_HDR_READ);
+        RT_CASE_RET_STR(VBOX_SHCL_HOST_MSG_URI_LIST_HDR_WRITE);
+        RT_CASE_RET_STR(VBOX_SHCL_HOST_MSG_URI_LIST_ENTRY_READ);
+        RT_CASE_RET_STR(VBOX_SHCL_HOST_MSG_URI_LIST_ENTRY_WRITE);
+        RT_CASE_RET_STR(VBOX_SHCL_HOST_MSG_URI_OBJ_OPEN);
+        RT_CASE_RET_STR(VBOX_SHCL_HOST_MSG_URI_OBJ_CLOSE);
+        RT_CASE_RET_STR(VBOX_SHCL_HOST_MSG_URI_OBJ_READ);
+        RT_CASE_RET_STR(VBOX_SHCL_HOST_MSG_URI_OBJ_WRITE);
+        RT_CASE_RET_STR(VBOX_SHCL_HOST_MSG_URI_CANCEL);
+        RT_CASE_RET_STR(VBOX_SHCL_HOST_MSG_URI_ERROR);
     }
     return "Unknown";
@@ -856,34 +856,34 @@
  * @param   uMsg                The message to translate.
  */
-const char *VBoxClipboardGuestMsgToStr(uint32_t uMsg)
+const char *VBoxShClGuestMsgToStr(uint32_t uMsg)
 {
     switch (uMsg)
     {
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_GUEST_FN_GET_HOST_MSG_OLD);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_GUEST_FN_FORMATS_REPORT);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_GUEST_FN_DATA_READ);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_GUEST_FN_DATA_WRITE);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_GUEST_FN_CONNECT);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_GUEST_FN_MSG_PEEK_NOWAIT);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_GUEST_FN_MSG_PEEK_WAIT);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_GUEST_FN_MSG_GET);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_GUEST_FN_STATUS);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_GUEST_FN_REPLY);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_GUEST_FN_ROOT_LIST_HDR_READ);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_GUEST_FN_ROOT_LIST_HDR_WRITE);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_GUEST_FN_ROOT_LIST_ENTRY_READ);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_GUEST_FN_ROOT_LIST_ENTRY_WRITE);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_GUEST_FN_LIST_OPEN);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_GUEST_FN_LIST_CLOSE);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_GUEST_FN_LIST_HDR_READ);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_GUEST_FN_LIST_HDR_WRITE);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_GUEST_FN_LIST_ENTRY_READ);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_GUEST_FN_LIST_ENTRY_WRITE);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_GUEST_FN_OBJ_OPEN);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_GUEST_FN_OBJ_CLOSE);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_GUEST_FN_OBJ_READ);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_GUEST_FN_OBJ_WRITE);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_GUEST_FN_CANCEL);
-        RT_CASE_RET_STR(VBOX_SHARED_CLIPBOARD_GUEST_FN_ERROR);
+        RT_CASE_RET_STR(VBOX_SHCL_GUEST_FN_GET_HOST_MSG_OLD);
+        RT_CASE_RET_STR(VBOX_SHCL_GUEST_FN_FORMATS_REPORT);
+        RT_CASE_RET_STR(VBOX_SHCL_GUEST_FN_DATA_READ);
+        RT_CASE_RET_STR(VBOX_SHCL_GUEST_FN_DATA_WRITE);
+        RT_CASE_RET_STR(VBOX_SHCL_GUEST_FN_CONNECT);
+        RT_CASE_RET_STR(VBOX_SHCL_GUEST_FN_MSG_PEEK_NOWAIT);
+        RT_CASE_RET_STR(VBOX_SHCL_GUEST_FN_MSG_PEEK_WAIT);
+        RT_CASE_RET_STR(VBOX_SHCL_GUEST_FN_MSG_GET);
+        RT_CASE_RET_STR(VBOX_SHCL_GUEST_FN_STATUS);
+        RT_CASE_RET_STR(VBOX_SHCL_GUEST_FN_REPLY);
+        RT_CASE_RET_STR(VBOX_SHCL_GUEST_FN_ROOT_LIST_HDR_READ);
+        RT_CASE_RET_STR(VBOX_SHCL_GUEST_FN_ROOT_LIST_HDR_WRITE);
+        RT_CASE_RET_STR(VBOX_SHCL_GUEST_FN_ROOT_LIST_ENTRY_READ);
+        RT_CASE_RET_STR(VBOX_SHCL_GUEST_FN_ROOT_LIST_ENTRY_WRITE);
+        RT_CASE_RET_STR(VBOX_SHCL_GUEST_FN_LIST_OPEN);
+        RT_CASE_RET_STR(VBOX_SHCL_GUEST_FN_LIST_CLOSE);
+        RT_CASE_RET_STR(VBOX_SHCL_GUEST_FN_LIST_HDR_READ);
+        RT_CASE_RET_STR(VBOX_SHCL_GUEST_FN_LIST_HDR_WRITE);
+        RT_CASE_RET_STR(VBOX_SHCL_GUEST_FN_LIST_ENTRY_READ);
+        RT_CASE_RET_STR(VBOX_SHCL_GUEST_FN_LIST_ENTRY_WRITE);
+        RT_CASE_RET_STR(VBOX_SHCL_GUEST_FN_OBJ_OPEN);
+        RT_CASE_RET_STR(VBOX_SHCL_GUEST_FN_OBJ_CLOSE);
+        RT_CASE_RET_STR(VBOX_SHCL_GUEST_FN_OBJ_READ);
+        RT_CASE_RET_STR(VBOX_SHCL_GUEST_FN_OBJ_WRITE);
+        RT_CASE_RET_STR(VBOX_SHCL_GUEST_FN_CANCEL);
+        RT_CASE_RET_STR(VBOX_SHCL_GUEST_FN_ERROR);
     }
     return "Unknown";