Index: trunk/src/VBox/HostServices/SharedClipboard/Makefile.kmk
===================================================================
--- trunk/src/VBox/HostServices/SharedClipboard/Makefile.kmk	(revision 80848)
+++ trunk/src/VBox/HostServices/SharedClipboard/Makefile.kmk	(revision 80849)
@@ -29,5 +29,5 @@
 VBoxSharedClipboard_DEFS      = \
 	VBOX_WITH_HGCM \
-	$(if $(VBOX_WITH_SHARED_CLIPBOARD_URI_LIST),VBOX_WITH_SHARED_CLIPBOARD_URI_LIST,)
+	$(if $(VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS),VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS,)
 VBoxSharedClipboard_INCS.win  = \
 	$(VBOX_PATH_SDK)
@@ -44,5 +44,5 @@
 	VBoxSharedClipboardSvc-darwin.cpp \
 	darwin-pasteboard.cpp
-ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
  VBoxSharedClipboard_DEFS    += VBOX_WITH_SHARED_CLIPBOARD_HOST
  VBoxSharedClipboard_SOURCES += \
Index: trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-darwin.cpp
===================================================================
--- trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-darwin.cpp	(revision 80848)
+++ trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-darwin.cpp	(revision 80849)
@@ -214,5 +214,5 @@
     }
 
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
     if (pFormats->uFormats & VBOX_SHCL_FMT_URI_LIST) /* No URI support yet. */
         return VINF_SUCCESS;
@@ -276,5 +276,5 @@
 }
 
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
 int SharedClipboardSvcImplURIReadDir(PSHCLCLIENT pClient, PSHCLDIRDATA pDirData)
 {
@@ -312,4 +312,4 @@
     return VERR_NOT_IMPLEMENTED;
 }
-#endif /* VBOX_WITH_SHARED_CLIPBOARD_URI_LIST */
-
+#endif /* VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS */
+
Index: trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-internal.h
===================================================================
--- trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-internal.h	(revision 80848)
+++ trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-internal.h	(revision 80849)
@@ -39,7 +39,7 @@
 using namespace HGCM;
 
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
 struct SHCLCLIENTSTATE;
-#endif /* VBOX_WITH_SHARED_CLIPBOARD_URI_LIST */
+#endif /* VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS */
 
 /**
@@ -111,5 +111,5 @@
      *  Needed for events which are not bound to a specific transfer. */
     SHCLEVENTSOURCE          Events;
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
     /** URI context data. */
     SHCLURICTX               URI;
@@ -196,10 +196,10 @@
 int sharedClipboardSvcClientWakeup(PSHCLCLIENT pClient);
 
-# ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+# ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
 int sharedClipboardSvcURITransferStart(PSHCLCLIENT pClient,
                                      SHCLURITRANSFERDIR enmDir, SHCLSOURCE enmSource,
                                      PSHCLURITRANSFER *ppTransfer);
 bool sharedClipboardSvcURIMsgIsAllowed(uint32_t uMode, uint32_t uMsg);
-# endif /* VBOX_WITH_SHARED_CLIPBOARD_URI_LIST */
+# endif /* VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS */
 
 /*
@@ -221,5 +221,5 @@
 int SharedClipboardSvcImplSync(PSHCLCLIENT pClient);
 
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
 int sharedClipboardSvcURITransferOpen(PSHCLPROVIDERCTX pCtx);
 DECLCALLBACK(int) sharedClipboardSvcURITransferClose(PSHCLPROVIDERCTX pCtx);
@@ -251,5 +251,5 @@
 int SharedClipboardSvcImplURITransferCreate(PSHCLCLIENT pClient, PSHCLURITRANSFER pTransfer);
 int SharedClipboardSvcImplURITransferDestroy(PSHCLCLIENT pClient, PSHCLURITRANSFER pTransfer);
-#endif /*VBOX_WITH_SHARED_CLIPBOARD_URI_LIST */
+#endif /*VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS */
 
 /* Host unit testing interface */
Index: trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-utils.cpp
===================================================================
--- trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-utils.cpp	(revision 80848)
+++ trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-utils.cpp	(revision 80849)
@@ -32,5 +32,5 @@
 
 
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
 /**
  * Returns whether a HGCM message is allowed in a certain service mode or not.
@@ -150,4 +150,4 @@
 }
 #endif
-#endif /* VBOX_WITH_SHARED_CLIPBOARD_URI_LIST */
+#endif /* VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS */
 
Index: trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-win.cpp
===================================================================
--- trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-win.cpp	(revision 80848)
+++ trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-win.cpp	(revision 80849)
@@ -26,5 +26,5 @@
 #include <VBox/GuestHost/clipboard-helper.h>
 #include <VBox/GuestHost/SharedClipboard-win.h>
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
 # include <VBox/GuestHost/SharedClipboard-uri.h>
 #endif
@@ -37,5 +37,5 @@
 #include <iprt/semaphore.h>
 #include <iprt/thread.h>
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
 # include <iprt/utf16.h>
 #endif
@@ -45,5 +45,5 @@
 
 #include "VBoxSharedClipboardSvc-internal.h"
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
 # include "VBoxSharedClipboardSvc-uri.h"
 #endif
@@ -336,5 +336,5 @@
                 break;
 
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
             if (fFormats & VBOX_SHCL_FMT_URI_LIST)
             {
@@ -367,5 +367,5 @@
                     SharedClipboardWinClose();
                 }
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
             }
 #endif
@@ -492,5 +492,5 @@
             }
 
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
             if (RT_SUCCESS(rc))
             {
@@ -525,5 +525,5 @@
             LogFunc(("Message loop finished. GetMessage returned %d, message id: %d \n", msgret, msg.message));
 
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
             OleSetClipboard(NULL); /* Make sure to flush the clipboard on destruction. */
             OleUninitialize();
@@ -590,5 +590,5 @@
 int SharedClipboardSvcImplInit(void)
 {
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
     HRESULT hr = OleInitialize(NULL);
     if (FAILED(hr))
@@ -606,5 +606,5 @@
 void SharedClipboardSvcImplDestroy(void)
 {
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
     OleSetClipboard(NULL); /* Make sure to flush the clipboard on destruction. */
     OleUninitialize();
@@ -812,10 +812,10 @@
             }
         }
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
         else if (pData->uFormat & VBOX_SHCL_FMT_URI_LIST)
         {
             AssertFailed(); /** @todo */
         }
-#endif /* VBOX_WITH_SHARED_CLIPBOARD_URI_LIST */
+#endif /* VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS */
         SharedClipboardWinClose();
     }
@@ -842,5 +842,5 @@
 }
 
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
 int SharedClipboardSvcImplURITransferCreate(PSHCLCLIENT pClient, PSHCLURITRANSFER pTransfer)
 {
@@ -860,4 +860,4 @@
     return VINF_SUCCESS;
 }
-#endif /* VBOX_WITH_SHARED_CLIPBOARD_URI_LIST */
-
+#endif /* VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS */
+
Index: trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-x11.cpp
===================================================================
--- trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-x11.cpp	(revision 80848)
+++ trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-x11.cpp	(revision 80849)
@@ -204,5 +204,5 @@
     RT_NOREF(pCmdCtx);
 
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
     if (pFormats->uFormats & VBOX_SHCL_FMT_URI_LIST) /* No URI support yet. */
         return VINF_SUCCESS;
@@ -389,5 +389,5 @@
 }
 
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
 int SharedClipboardSvcImplURITransferCreate(PSHCLCLIENT pClient, PSHCLURITRANSFER pTransfer)
 {
Index: trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc.cpp
===================================================================
--- trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc.cpp	(revision 80848)
+++ trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc.cpp	(revision 80849)
@@ -84,5 +84,5 @@
  *
  * Since VBox x.x.x transferring files via Shared Clipboard is supported.
- * See the VBOX_WITH_SHARED_CLIPBOARD_URI_LIST define for supported / enabled
+ * See the VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS define for supported / enabled
  * platforms. This is called "URI transfers".
  *
@@ -214,5 +214,5 @@
 
 #include "VBoxSharedClipboardSvc-internal.h"
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
 # include "VBoxSharedClipboardSvc-uri.h"
 #endif
@@ -1099,5 +1099,5 @@
     AssertPtr(pClient);
 
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
     PSHCLURITRANSFER pTransfer = SharedClipboardURICtxGetTransfer(&pClient->URI, 0 /* Index*/);
     if (pTransfer)
@@ -1149,5 +1149,5 @@
         {
             rc = SharedClipboardSvcImplConnect(pClient, VBoxSvcClipboardGetHeadless());
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
             if (RT_SUCCESS(rc))
                 rc = SharedClipboardURICtxInit(&pClient->URI);
@@ -1375,5 +1375,5 @@
                 if (RT_SUCCESS(rc))
                 {
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
                     if (uFormat == VBOX_SHCL_FMT_URI_LIST)
                     {
@@ -1385,5 +1385,5 @@
                     else
                     {
-#endif /* VBOX_WITH_SHARED_CLIPBOARD_URI_LIST */
+#endif /* VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS */
                         void    *pv;
                         uint32_t cb;
@@ -1458,5 +1458,5 @@
                             }
                         }
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
                     }
 #endif
@@ -1475,5 +1475,5 @@
         default:
         {
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
             rc = sharedClipboardSvcURIHandler(pClient, callHandle, u32Function, cParms, paParms, tsArrival);
 #else
@@ -1537,5 +1537,5 @@
     LogFlowFuncEnter();
 
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
     pClientState->URI.enmTransferDir = SHCLURITRANSFERDIR_UNKNOWN;
 #else
@@ -1598,5 +1598,5 @@
         default:
         {
-#ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
+#ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
             rc = sharedClipboardSvcURIHostHandler(u32Function, cParms, paParms);
 #else