Index: trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-internal.h
===================================================================
--- trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-internal.h	(revision 80863)
+++ trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-internal.h	(revision 80866)
@@ -197,7 +197,8 @@
 
 # ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
-int sharedClipboardSvcTransferTransferStart(PSHCLCLIENT pClient,
-                                     SHCLTRANSFERDIR enmDir, SHCLSOURCE enmSource,
-                                     PSHCLTRANSFER *ppTransfer);
+int sharedClipboardSvcTransferStart(PSHCLCLIENT pClient,
+                                    SHCLTRANSFERDIR enmDir, SHCLSOURCE enmSource,
+                                    PSHCLTRANSFER *ppTransfer);
+int sharedClipboardSvcTransferStop(PSHCLCLIENT pClient, PSHCLTRANSFER pTransfer);
 bool sharedClipboardSvcTransferMsgIsAllowed(uint32_t uMode, uint32_t uMsg);
 # endif /* VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS */
@@ -222,6 +223,6 @@
 
 #ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
-int sharedClipboardSvcTransferTransferOpen(PSHCLPROVIDERCTX pCtx);
-DECLCALLBACK(int) sharedClipboardSvcTransferTransferClose(PSHCLPROVIDERCTX pCtx);
+int sharedClipboardSvcTransferOpen(PSHCLPROVIDERCTX pCtx);
+DECLCALLBACK(int) sharedClipboardSvcTransferClose(PSHCLPROVIDERCTX pCtx);
 
 int sharedClipboardSvcTransferGetRoots(PSHCLPROVIDERCTX pCtx, PSHCLROOTLIST *ppRootList);
Index: trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-transfers.cpp
===================================================================
--- trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-transfers.cpp	(revision 80863)
+++ trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-transfers.cpp	(revision 80866)
@@ -58,5 +58,5 @@
 *********************************************************************************************************************************/
 
-DECLCALLBACK(int) sharedClipboardSvcTransferTransferOpen(PSHCLPROVIDERCTX pCtx)
+DECLCALLBACK(int) sharedClipboardSvcTransferOpen(PSHCLPROVIDERCTX pCtx)
 {
     RT_NOREF(pCtx);
@@ -66,5 +66,5 @@
 }
 
-DECLCALLBACK(int) sharedClipboardSvcTransferTransferClose(PSHCLPROVIDERCTX pCtx)
+DECLCALLBACK(int) sharedClipboardSvcTransferClose(PSHCLPROVIDERCTX pCtx)
 {
     RT_NOREF(pCtx);
@@ -1162,6 +1162,6 @@
  * @param   paParms             Array function parameters supplied.
  */
-static int sharedClipboardSvcTransferTransferHandleReply(PSHCLCLIENT pClient, PSHCLTRANSFER pTransfer,
-                                                         uint32_t cParms, VBOXHGCMSVCPARM paParms[])
+static int sharedClipboardSvcTransferHandleReply(PSHCLCLIENT pClient, PSHCLTRANSFER pTransfer,
+                                                 uint32_t cParms, VBOXHGCMSVCPARM paParms[])
 {
     RT_NOREF(pClient);
@@ -1366,6 +1366,6 @@
                         creationCtx.enmSource = pClient->State.enmSource;
 
-                        creationCtx.Interface.pfnTransferOpen  = sharedClipboardSvcTransferTransferOpen;
-                        creationCtx.Interface.pfnTransferClose = sharedClipboardSvcTransferTransferClose;
+                        creationCtx.Interface.pfnTransferOpen  = sharedClipboardSvcTransferOpen;
+                        creationCtx.Interface.pfnTransferClose = sharedClipboardSvcTransferClose;
                         creationCtx.Interface.pfnListOpen      = sharedClipboardSvcTransferListOpen;
                         creationCtx.Interface.pfnListClose     = sharedClipboardSvcTransferListClose;
@@ -1431,5 +1431,5 @@
         case VBOX_SHCL_GUEST_FN_REPLY:
         {
-            rc = sharedClipboardSvcTransferTransferHandleReply(pClient, pTransfer, cParms, paParms);
+            rc = sharedClipboardSvcTransferHandleReply(pClient, pTransfer, cParms, paParms);
 
             /* This message does not need any completion, as it can happen at any time from the guest side. */
@@ -2099,6 +2099,6 @@
  * @param   puEvent             Where to store the created wait event. Optional.
  */
-int sharedClipboardSvcTransferTransferSendStatus(PSHCLCLIENT pClient, PSHCLTRANSFER pTransfer, SHCLTRANSFERSTATUS uStatus,
-                                                 int rcTransfer, PSHCLEVENTID puEvent)
+int sharedClipboardSvcTransferSendStatus(PSHCLCLIENT pClient, PSHCLTRANSFER pTransfer, SHCLTRANSFERSTATUS uStatus,
+                                         int rcTransfer, PSHCLEVENTID puEvent)
 {
     AssertPtrReturn(pClient,   VERR_INVALID_POINTER);
@@ -2153,7 +2153,7 @@
  * @param   ppTransfer          Where to return the created transfer on success. Optional.
  */
-int sharedClipboardSvcTransferTransferStart(PSHCLCLIENT pClient,
-                                            SHCLTRANSFERDIR enmDir, SHCLSOURCE enmSource,
-                                            PSHCLTRANSFER *ppTransfer)
+int sharedClipboardSvcTransferStart(PSHCLCLIENT pClient,
+                                    SHCLTRANSFERDIR enmDir, SHCLSOURCE enmSource,
+                                    PSHCLTRANSFER *ppTransfer)
 {
     AssertPtrReturn(pClient, VERR_INVALID_POINTER);
@@ -2182,6 +2182,6 @@
                 if (RT_SUCCESS(rc))
                 {
-                    creationCtx.Interface.pfnTransferOpen    = sharedClipboardSvcTransferTransferOpen;
-                    creationCtx.Interface.pfnTransferClose   = sharedClipboardSvcTransferTransferClose;
+                    creationCtx.Interface.pfnTransferOpen    = sharedClipboardSvcTransferOpen;
+                    creationCtx.Interface.pfnTransferClose   = sharedClipboardSvcTransferClose;
                     creationCtx.Interface.pfnListOpen        = sharedClipboardSvcTransferListOpen;
                     creationCtx.Interface.pfnListClose       = sharedClipboardSvcTransferListClose;
@@ -2235,7 +2235,7 @@
                         {
                             SHCLEVENTID uEvent;
-                            rc = sharedClipboardSvcTransferTransferSendStatus(pClient, pTransfer,
-                                                                              SHCLTRANSFERSTATUS_READY, VINF_SUCCESS,
-                                                                              &uEvent);
+                            rc = sharedClipboardSvcTransferSendStatus(pClient, pTransfer,
+                                                                      SHCLTRANSFERSTATUS_READY, VINF_SUCCESS,
+                                                                      &uEvent);
                             if (RT_SUCCESS(rc))
                             {
@@ -2304,5 +2304,5 @@
  * @param   pTransfer           Transfer to stop.
  */
-int sharedClipboardSvcTransferTransferStop(PSHCLCLIENT pClient, PSHCLTRANSFER pTransfer)
+int sharedClipboardSvcTransferStop(PSHCLCLIENT pClient, PSHCLTRANSFER pTransfer)
 {
     int rc = SharedClipboardTransferClose(pTransfer);
@@ -2310,7 +2310,7 @@
     {
         SHCLEVENTID uEvent;
-        rc = sharedClipboardSvcTransferTransferSendStatus(pClient, pTransfer,
-                                                          SHCLTRANSFERSTATUS_STOPPED, VINF_SUCCESS,
-                                                          &uEvent);
+        rc = sharedClipboardSvcTransferSendStatus(pClient, pTransfer,
+                                                  SHCLTRANSFERSTATUS_STOPPED, VINF_SUCCESS,
+                                                  &uEvent);
         if (RT_SUCCESS(rc))
         {
Index: trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-win.cpp
===================================================================
--- trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-win.cpp	(revision 80863)
+++ trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-win.cpp	(revision 80866)
@@ -340,7 +340,7 @@
             {
                 PSHCLTRANSFER pTransfer;
-                int rc = sharedClipboardSvcTransferTransferStart(pCtx->pClient,
-                                                                 SHCLTRANSFERDIR_READ, SHCLSOURCE_REMOTE,
-                                                                 &pTransfer);
+                int rc = sharedClipboardSvcTransferStart(pCtx->pClient,
+                                                         SHCLTRANSFERDIR_READ, SHCLSOURCE_REMOTE,
+                                                         &pTransfer);
                 if (RT_SUCCESS(rc))
                 {
Index: trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc.cpp
===================================================================
--- trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc.cpp	(revision 80863)
+++ trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc.cpp	(revision 80866)
@@ -1378,6 +1378,6 @@
                     if (uFormat == VBOX_SHCL_FMT_URI_LIST)
                     {
-                        rc = sharedClipboardSvcTransferTransferStart(pClient, SHCLTRANSFERDIR_WRITE, SHCLSOURCE_LOCAL,
-                                                                     NULL /* pTransfer */);
+                        rc = sharedClipboardSvcTransferStart(pClient, SHCLTRANSFERDIR_WRITE, SHCLSOURCE_LOCAL,
+                                                             NULL /* pTransfer */);
                         if (RT_FAILURE(rc))
                             LogRel(("Shared Clipboard: Initializing host write transfer failed with %Rrc\n", rc));