Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationConfiguration.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationConfiguration.cpp	(revision 80912)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationConfiguration.cpp	(revision 80913)
@@ -47,5 +47,4 @@
     prepareObjects();
     retranslateUi();
-    createTableItems();
     connect(gVBoxEvents, &UIVirtualBoxEventHandler::sigMachineDataChange,
             this, &UIInformationConfiguration::sltMachineDataChanged);
@@ -54,5 +53,4 @@
 void UIInformationConfiguration::sltMachineDataChanged()
 {
-    resetTable();
     createTableItems();
 }
@@ -69,4 +67,5 @@
     m_strUSBTitle = QApplication::translate("UIVMInformationDialog", "USB");
     m_strSharedFoldersTitle = QApplication::translate("UIVMInformationDialog", "Shared Folders");
+    createTableItems();
 }
 
@@ -75,4 +74,5 @@
     if (!m_pTableWidget)
         return;
+    resetTable();
     QFontMetrics fontMetrics(m_pTableWidget->font());
     QTextDocument textDocument;
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationRuntime.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationRuntime.cpp	(revision 80912)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationRuntime.cpp	(revision 80913)
@@ -102,5 +102,5 @@
     void createInfoRows();
     void updateUpTime();
-
+    void updateTitleRow();
 
     /** Searches the table for the @p item of enmLine and replaces its text. if not found inserts a new
@@ -108,5 +108,5 @@
     void updateInfoRow(InfoRow enmLine, const QString &strColumn0, const QString &strColumn1);
     QString screenResolution(int iScreenId);
-    /** Creates to QTableWidgetItems of tye @enmInfoRow using the @p strLabel and @p strInfo and inserts it
+    /** Creates to QTableWidgetItems of the @enmInfoRow using the @p strLabel and @p strInfo and inserts it
      * to the row @p iRow. If @p iRow is -1 then the items inserted to the end of the table. */
     void insertInfoRow(InfoRow enmInfoRow, const QString& strLabel, const QString &strInfo, int iRow = -1);
@@ -244,5 +244,4 @@
     , m_iMinimumWidth(0)
     , m_pTimer(0)
-
 {
     setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
@@ -266,13 +265,4 @@
 
     retranslateUi();
-    /* Add the title row: */
-    QTableWidgetItem *pTitleItem = new QTableWidgetItem(UIIconPool::iconSet(":/state_running_16px.png"), m_strTableTitle, InfoRow_Title);
-    QFont titleFont(font());
-    titleFont.setBold(true);
-    pTitleItem->setFont(titleFont);
-    insertRow(0);
-    setItem(0, 0, pTitleItem);
-    /* Make the API calls and populate the table: */
-    createInfoRows();
     computeMinimumWidth();
 }
@@ -298,4 +288,7 @@
     m_strNotSet = QApplication::translate("UIVMInformationDialog", "not set");
     m_strNotDetected = QApplication::translate("UIVMInformationDialog", "Not Detected");
+
+    /* Make the API calls and populate the table: */
+    createInfoRows();
 }
 
@@ -312,5 +305,4 @@
 void UIRuntimeInfoWidget::insertInfoRow(InfoRow enmInfoRow, const QString& strLabel, const QString &strInfo, int iRow /* = -1 */)
 {
-    int iMargin = 0.2 * qApp->style()->pixelMetric(QStyle::PM_LayoutTopMargin);
     int iNewRow = rowCount();
     if (iRow != -1 && iRow <= iNewRow)
@@ -319,4 +311,5 @@
     setItem(iNewRow, 0, new QTableWidgetItem(strLabel, enmInfoRow));
     setItem(iNewRow, 1, new QTableWidgetItem(strInfo, enmInfoRow));
+    int iMargin = 0.2 * qApp->style()->pixelMetric(QStyle::PM_LayoutTopMargin);
     setRowHeight(iNewRow, 2 * iMargin + m_iFontHeight);
 }
@@ -398,4 +391,16 @@
 }
 
+void UIRuntimeInfoWidget::updateTitleRow()
+{
+    /* Add the title row always as 0th row: */
+    QTableWidgetItem *pTitleItem = new QTableWidgetItem(UIIconPool::iconSet(":/state_running_16px.png"), m_strTableTitle, InfoRow_Title);
+    QFont titleFont(font());
+    titleFont.setBold(true);
+    pTitleItem->setFont(titleFont);
+    if (rowCount() < 1)
+        insertRow(0);
+    setItem(0, 0, pTitleItem);
+}
+
 void UIRuntimeInfoWidget::updateGAsVersion()
 {
@@ -460,4 +465,8 @@
 void UIRuntimeInfoWidget::createInfoRows()
 {
+    clear();
+    setRowCount(0);
+    setColumnCount(2);
+    updateTitleRow();
     updateScreenInfo();
     updateUpTime();
@@ -649,4 +658,5 @@
     m_strResetActionLabel = QApplication::translate("UIVMInformationDialog", "Reset");
     m_strPieChartToggleActionLabel = QApplication::translate("UIVMInformationDialog", "Show Pie Chart");
+    update();
 }
 
@@ -1234,4 +1244,5 @@
         }
     }
+    sltTimeout();
 }
 