Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIEmptyFilePathSelector.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIEmptyFilePathSelector.cpp	(revision 80954)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIEmptyFilePathSelector.cpp	(revision 80955)
@@ -62,5 +62,5 @@
 #endif
     mSelectButton->setIcon(UIIconPool::iconSet(":/select_file_16px.png", ":/select_file_disabled_16px.png"));
-    connect(mSelectButton, SIGNAL(clicked()), this, SLOT(choose()));
+    connect(mSelectButton, &QToolButton::clicked, this, &UIEmptyFilePathSelector::choose);
     mMainLayout->addWidget(mSelectButton);
 
@@ -254,3 +254,2 @@
     }
 }
-
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFilePathSelector.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFilePathSelector.cpp	(revision 80954)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFilePathSelector.cpp	(revision 80955)
@@ -96,6 +96,6 @@
 
     /* Setup connections: */
-    connect(this, SIGNAL(activated(int)), this, SLOT(onActivated(int)));
-    connect(m_pCopyAction, SIGNAL(triggered(bool)), this, SLOT(copyToClipboard()));
+    connect(this, static_cast<void(UIFilePathSelector::*)(int)>(&UIFilePathSelector::activated), this, &UIFilePathSelector::onActivated);
+    connect(m_pCopyAction, &QAction::triggered, this, &UIFilePathSelector::copyToClipboard);
 
     /* Editable by default: */
@@ -127,6 +127,6 @@
         /* Install line-edit connection/event-filter: */
         Assert(lineEdit());
-        connect(lineEdit(), SIGNAL(textEdited(const QString &)),
-                this, SLOT(onTextEdited(const QString &)));
+        connect(lineEdit(), &QLineEdit::textEdited,
+                this, &UIFilePathSelector::onTextEdited);
         lineEdit()->installEventFilter(this);
     }
@@ -137,6 +137,6 @@
             /* Remove line-edit event-filter/connection: */
             lineEdit()->removeEventFilter(this);
-            disconnect(lineEdit(), SIGNAL(textEdited(const QString &)),
-                       this, SLOT(onTextEdited(const QString &)));
+            disconnect(lineEdit(), &QLineEdit::textEdited,
+                       this, &UIFilePathSelector::onTextEdited);
         }
         if (comboBox())
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIHostComboEditor.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIHostComboEditor.cpp	(revision 80954)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIHostComboEditor.cpp	(revision 80955)
@@ -492,5 +492,5 @@
             /* Configure UIHostComboEditorPrivate instance: */
             setFocusProxy(m_pEditor);
-            connect(m_pEditor, SIGNAL(sigDataChanged()), this, SLOT(sltCommitData()));
+            connect(m_pEditor, &UIHostComboEditorPrivate::sigDataChanged, this, &UIHostComboEditor::sltCommitData);
         }
         /* Create 'clear' tool-button: */
@@ -500,5 +500,5 @@
             m_pButtonClear->removeBorder();
             m_pButtonClear->setIcon(UIIconPool::iconSet(":/eraser_16px.png"));
-            connect(m_pButtonClear, SIGNAL(clicked(bool)), m_pEditor, SLOT(sltClear()));
+            connect(m_pButtonClear, &QIToolButton::clicked, m_pEditor, &UIHostComboEditorPrivate::sltClear);
         }
         /* Add widgets to layout: */
@@ -541,10 +541,10 @@
     setContextMenuPolicy(Qt::NoContextMenu);
     setSizePolicy(QSizePolicy::MinimumExpanding, QSizePolicy::Expanding);
-    connect(this, SIGNAL(selectionChanged()), this, SLOT(sltDeselect()));
+    connect(this, &UIHostComboEditorPrivate::selectionChanged, this, &UIHostComboEditorPrivate::sltDeselect);
 
     /* Setup release-pending-keys timer: */
     m_pReleaseTimer = new QTimer(this);
     m_pReleaseTimer->setInterval(200);
-    connect(m_pReleaseTimer, SIGNAL(timeout()), this, SLOT(sltReleasePendingKeys()));
+    connect(m_pReleaseTimer, &QTimer::timeout, this, &UIHostComboEditorPrivate::sltReleasePendingKeys);
 
 #if defined(VBOX_WS_MAC) || defined(VBOX_WS_WIN)
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIHotKeyEditor.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIHotKeyEditor.cpp	(revision 80954)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIHotKeyEditor.cpp	(revision 80955)
@@ -71,5 +71,5 @@
 
     /* Connect selection preserver: */
-    connect(this, SIGNAL(selectionChanged()), this, SLOT(sltDeselect()));
+    connect(this, &UIHotKeyLineEdit::selectionChanged, this, &UIHotKeyLineEdit::sltDeselect);
 }
 
@@ -155,8 +155,8 @@
     m_pResetButton->removeBorder();
     m_pResetButton->setIcon(UIIconPool::iconSet(":/import_16px.png"));
-    connect(m_pResetButton, SIGNAL(clicked(bool)), this, SLOT(sltReset()));
+    connect(m_pResetButton, &QToolButton::clicked, this, &UIHotKeyEditor::sltReset);
     m_pClearButton->removeBorder();
     m_pClearButton->setIcon(UIIconPool::iconSet(":/eraser_16px.png"));
-    connect(m_pClearButton, SIGNAL(clicked(bool)), this, SLOT(sltClear()));
+    connect(m_pClearButton, &QToolButton::clicked, this, &UIHotKeyEditor::sltClear);
 
     /* Translate finally: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIMenuBarEditorWindow.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIMenuBarEditorWindow.cpp	(revision 80954)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIMenuBarEditorWindow.cpp	(revision 80955)
@@ -1071,6 +1071,6 @@
         setRestrictionsOfMenuHelp(gEDataManager->restrictedRuntimeMenuHelpActionTypes(machineID()));
         /* And listen for the menu-bar configuration changes after that: */
-        connect(gEDataManager, SIGNAL(sigMenuBarConfigurationChange(const QString&)),
-                this, SLOT(sltHandleConfigurationChange(const QString&)));
+        connect(gEDataManager, &UIExtraDataManager::sigMenuBarConfigurationChange,
+                this, &UIMenuBarEditorWidget::sltHandleConfigurationChange);
     }
 }
@@ -1139,5 +1139,5 @@
             pCopiedMenuAction->setProperty("class", UIExtraDataMetaDefs::MenuType_All);
             pCopiedMenuAction->setProperty("type", pAction->extraDataID());
-            connect(pCopiedMenuAction, SIGNAL(triggered(bool)), this, SLOT(sltHandleMenuBarMenuClick()));
+            connect(pCopiedMenuAction, &QAction::triggered, this, &UIMenuBarEditorWidget::sltHandleMenuBarMenuClick);
             m_actions.insert(pAction->extraDataKey(), pCopiedMenuAction);
             /* Add menu action into tool-bar: */
@@ -1191,5 +1191,5 @@
             pCopiedMenuAction->setProperty("class", pCopiedMenu->property("class"));
             pCopiedMenuAction->setProperty("type", pAction->extraDataID());
-            connect(pCopiedMenuAction, SIGNAL(triggered(bool)), this, SLOT(sltHandleMenuBarMenuClick()));
+            connect(pCopiedMenuAction, &QAction::triggered, &UIMenuBarEditorWidget::sltHandleMenuBarMenuClick);
             m_actions.insert(pAction->extraDataKey(), pCopiedMenuAction);
         }
@@ -1211,5 +1211,5 @@
         pCopiedAction->setProperty("class", pMenu->property("class"));
         pCopiedAction->setProperty("type", iExtraDataID);
-        connect(pCopiedAction, SIGNAL(triggered(bool)), this, SLOT(sltHandleMenuBarMenuClick()));
+        connect(pCopiedAction, &QAction::triggered, this, &UIMenuBarEditorWidget::sltHandleMenuBarMenuClick);
         m_actions.insert(strExtraDataID, pCopiedAction);
     }
@@ -1228,5 +1228,5 @@
         pCopiedAction->setProperty("class", pMenu->property("class"));
         pCopiedAction->setProperty("type", pAction->extraDataID());
-        connect(pCopiedAction, SIGNAL(triggered(bool)), this, SLOT(sltHandleMenuBarMenuClick()));
+        connect(pCopiedAction, &QAction::triggered, this, &UIMenuBarEditorWidget::sltHandleMenuBarMenuClick);
         m_actions.insert(pAction->extraDataKey(), pCopiedAction);
     }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIMiniToolBar.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIMiniToolBar.cpp	(revision 80954)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIMiniToolBar.cpp	(revision 80955)
@@ -890,9 +890,9 @@
         m_pToolbar->setPalette(pal);
         /* Configure child connections: */
-        connect(m_pToolbar, SIGNAL(sigResized()), this, SLOT(sltHandleToolbarResize()));
-        connect(m_pToolbar, SIGNAL(sigAutoHideToggled()), this, SLOT(sltAutoHideToggled()));
-        connect(m_pToolbar, SIGNAL(sigMinimizeAction()), this, SIGNAL(sigMinimizeAction()));
-        connect(m_pToolbar, SIGNAL(sigExitAction()), this, SIGNAL(sigExitAction()));
-        connect(m_pToolbar, SIGNAL(sigCloseAction()), this, SIGNAL(sigCloseAction()));
+        connect(m_pToolbar, &UIMiniToolBarPrivate::sigResized, this, &UIMiniToolBar::sltHandleToolbarResize);
+        connect(m_pToolbar, &UIMiniToolBarPrivate::sigAutoHideToggled, this, &UIMiniToolBar::sltAutoHideToggled);
+        connect(m_pToolbar, &UIMiniToolBarPrivate::sigMinimizeAction, this, &UIMiniToolBar::sigMinimizeAction);
+        connect(m_pToolbar, &UIMiniToolBarPrivate::sigExitAction, this, &UIMiniToolBar::sigExitAction);
+        connect(m_pToolbar, &UIMiniToolBarPrivate::sigCloseAction, this, &UIMiniToolBar::sigCloseAction);
         /* Add child to area: */
         m_pToolbar->setParent(m_pArea);
@@ -906,5 +906,5 @@
         m_pHoverEnterTimer->setSingleShot(true);
         m_pHoverEnterTimer->setInterval(500);
-        connect(m_pHoverEnterTimer, SIGNAL(timeout()), this, SLOT(sltHoverEnter()));
+        connect(m_pHoverEnterTimer, &QTimer::timeout, this, &UIMiniToolBar::sltHoverEnter);
     }
     m_pHoverLeaveTimer = new QTimer(this);
@@ -912,5 +912,5 @@
         m_pHoverLeaveTimer->setSingleShot(true);
         m_pHoverLeaveTimer->setInterval(500);
-        connect(m_pHoverLeaveTimer, SIGNAL(timeout()), this, SLOT(sltHoverLeave()));
+        connect(m_pHoverLeaveTimer, &QTimer::timeout, this, &UIMiniToolBar::sltHoverLeave);
     }
 
@@ -1188,3 +1188,2 @@
 
 #include "UIMiniToolBar.moc"
-
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIPortForwardingTable.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIPortForwardingTable.cpp	(revision 80954)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIPortForwardingTable.cpp	(revision 80955)
@@ -1013,6 +1013,6 @@
         /* Finish configure table-view (after model is configured): */
         m_pTableView->setModel(m_pTableModel);
-        connect(m_pTableView, SIGNAL(sigCurrentChanged(const QModelIndex &, const QModelIndex &)), this, SLOT(sltCurrentChanged()));
-        connect(m_pTableView, SIGNAL(customContextMenuRequested(const QPoint &)), this, SLOT(sltShowTableContexMenu(const QPoint &)));
+        connect(m_pTableView, &UIPortForwardingView::sigCurrentChanged, this, &UIPortForwardingTable::sltCurrentChanged);
+        connect(m_pTableView, &UIPortForwardingView::customContextMenuRequested, this, &UIPortForwardingTable::sltShowTableContexMenu);
 
         /* Prepare delegates: */
@@ -1110,5 +1110,5 @@
             m_pActionAdd->setShortcut(QKeySequence("Ins"));
             m_pActionAdd->setIcon(UIIconPool::iconSet(":/controller_add_16px.png", ":/controller_add_disabled_16px.png"));
-            connect(m_pActionAdd, SIGNAL(triggered(bool)), this, SLOT(sltAddRule()));
+            connect(m_pActionAdd, &QAction::triggered, this, &UIPortForwardingTable::sltAddRule);
             m_pToolBar->addAction(m_pActionAdd);
         }
@@ -1120,5 +1120,5 @@
             /* Configure action: */
             m_pActionCopy->setIcon(UIIconPool::iconSet(":/controller_add_16px.png", ":/controller_add_disabled_16px.png"));
-            connect(m_pActionCopy, SIGNAL(triggered(bool)), this, SLOT(sltCopyRule()));
+            connect(m_pActionCopy, &QAction::triggered, this, &UIPortForwardingTable::sltCopyRule);
         }
 
@@ -1130,5 +1130,5 @@
             m_pActionRemove->setShortcut(QKeySequence("Del"));
             m_pActionRemove->setIcon(UIIconPool::iconSet(":/controller_remove_16px.png", ":/controller_remove_disabled_16px.png"));
-            connect(m_pActionRemove, SIGNAL(triggered(bool)), this, SLOT(sltRemoveRule()));
+            connect(m_pActionRemove, &QAction::triggered, this, &UIPortForwardingTable::sltRemoveRule);
             m_pToolBar->addAction(m_pActionRemove);
         }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIProgressDialog.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIProgressDialog.cpp	(revision 80954)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIProgressDialog.cpp	(revision 80955)
@@ -339,5 +339,5 @@
                     m_pButtonCancel->setEnabled(m_fCancelEnabled);
                     m_pButtonCancel->setFocusPolicy(Qt::ClickFocus);
-                    connect(m_pButtonCancel, SIGNAL(clicked()), this, SLOT(sltCancelOperation()));
+                    connect(m_pButtonCancel, &UIMiniCancelButton::clicked, this, &UIProgressDialog::sltCancelOperation);
 
                     /* Add into layout: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UISlidingToolBar.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UISlidingToolBar.cpp	(revision 80954)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UISlidingToolBar.cpp	(revision 80955)
@@ -24,4 +24,5 @@
 #include "UIAnimationFramework.h"
 #include "UIMachineWindow.h"
+#include "UIMenuBarEditorWindow.h"
 #ifdef VBOX_WS_MAC
 # include "VBoxUtils-darwin.h"
@@ -166,5 +167,7 @@
                 pal2.setColor(QPalette::Window, palette().color(QPalette::Window));
                 m_pWidget->setPalette(pal2);
-                connect(m_pWidget, SIGNAL(sigCancelClicked()), this, SLOT(close()));
+                UIMenuBarEditorWidget *pEditorWidget = qobject_cast<UIMenuBarEditorWidget*>(m_pWidget);
+                if (pEditorWidget)
+                    connect(pEditorWidget, &UIMenuBarEditorWidget::sigCancelClicked, this, &UISlidingToolBar::close);
                 /* Add child-widget into area: */
                 m_pWidget->setParent(m_pArea);
@@ -213,7 +216,8 @@
 
     /* Activate window after it was shown: */
-    connect(this, SIGNAL(sigShown()), this,
-            SLOT(sltActivateWindow()), Qt::QueuedConnection);
+    connect(this, &UISlidingToolBar::sigShown,
+            this, &UISlidingToolBar::sltActivateWindow, Qt::QueuedConnection);
     /* Update window geometry after parent geometry changed: */
+    /* Leave this in the old connection syntax for now: */
     connect(parent(), SIGNAL(sigGeometryChange(const QRect&)),
             this, SLOT(sltParentGeometryChanged(const QRect&)));
@@ -228,6 +232,6 @@
                                                          "startWidgetGeometry", "finalWidgetGeometry",
                                                          SIGNAL(sigExpand()), SIGNAL(sigCollapse()));
-    connect(m_pAnimation, SIGNAL(sigStateEnteredStart()), this, SLOT(sltMarkAsCollapsed()));
-    connect(m_pAnimation, SIGNAL(sigStateEnteredFinal()), this, SLOT(sltMarkAsExpanded()));
+    connect(m_pAnimation, &UIAnimation::sigStateEnteredStart, this, &UISlidingToolBar::sltMarkAsCollapsed);
+    connect(m_pAnimation, &UIAnimation::sigStateEnteredFinal, this, &UISlidingToolBar::sltMarkAsExpanded);
     /* Update geometry animation: */
     updateAnimation();
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIStatusBarEditorWindow.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIStatusBarEditorWindow.cpp	(revision 80954)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIStatusBarEditorWindow.cpp	(revision 80955)
@@ -845,6 +845,6 @@
                                   gEDataManager->statusBarIndicatorOrder(machineID()));
         /* And listen for the status-bar configuration changes after that: */
-        connect(gEDataManager, SIGNAL(sigStatusBarConfigurationChange(const QUuid &)),
-                this, SLOT(sltHandleConfigurationChange(const QUuid &)));
+        connect(gEDataManager, &UIExtraDataManager::sigStatusBarConfigurationChange,
+                this, &UIStatusBarEditorWidget::sltHandleConfigurationChange);
     }
 }
@@ -857,6 +857,6 @@
     {
         /* Configure status button: */
-        connect(pButton, SIGNAL(sigClick()), this, SLOT(sltHandleButtonClick()));
-        connect(pButton, SIGNAL(sigDragObjectDestroy()), this, SLOT(sltHandleDragObjectDestroy()));
+        connect(pButton, &UIStatusBarEditorButton::sigClick, this, &UIStatusBarEditorWidget::sltHandleButtonClick);
+        connect(pButton, &UIStatusBarEditorButton::sigDragObjectDestroy, this, &UIStatusBarEditorWidget::sltHandleDragObjectDestroy);
         /* Add status button into button-layout: */
         m_pButtonLayout->addWidget(pButton);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/graphics/UIGraphicsRotatorButton.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/graphics/UIGraphicsRotatorButton.cpp	(revision 80954)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/graphics/UIGraphicsRotatorButton.cpp	(revision 80955)
@@ -113,9 +113,9 @@
 {
     /* Disconnect button-click signal: */
-    disconnect(this, SIGNAL(sigButtonClicked()), this, SLOT(sltButtonClicked()));
+    disconnect(this, &UIGraphicsRotatorButton::sigButtonClicked, this, &UIGraphicsRotatorButton::sltButtonClicked);
     if (fEnabled)
     {
         /* Connect button-click signal: */
-        connect(this, SIGNAL(sigButtonClicked()), this, SLOT(sltButtonClicked()));
+        connect(this, &UIGraphicsRotatorButton::sigButtonClicked, this, &UIGraphicsRotatorButton::sltButtonClicked);
     }
 }
@@ -230,3 +230,2 @@
     }
 }
-